exec("./math.cs");
exec("./pastebin.cs");

if(isFile("config/client/zBot/knowledge.cs"))
{
	exec("config/client/zBot/knowledge.cs");
}

deActivatePackage(zBot_Client);
package zBot_Client
{
	function NMH_Type::send(%this)
	{
		parent::send(%this);
		%msg = %this.getValue();
		zBot_Check("Zapk",%msg);
	}
};
activatePackage(zBot_Client);

function zBot_Check(%name,%msg)
{
	if(firstword(%msg) $= "zbot," && stripMLControlChars(%name) $= "Zapk")
	{
		%name = stripMLControlChars(%name);
		%msge = restwords(%msg);
		%cmd = firstWord(%msge);
		%arg = restWords(%msge);
		
		if(isFunction(%func = "zBotCmd" @ %cmd))
		{
			call(%func, %name, %arg);
		}
		else
		{
			zBot_Message("Command '" @ %cmd @ "' not found.");
		}
	}
	else if($zBot_isDescribing && $zBot_DescriptionParent !$= "")
	{
		$zBot_Knowledge[$zBot_DescriptionParent] = %msg;
		$zBot_isDescribing = false;
		zBot_Message("Okay, I now know what" SPC strReplace($zBot_DescriptionParent, "_", " ") SPC "is.");
		export("$zBot_Knowledge*", "config/client/zBot/knowledge.cs");
	}
}

function zBot_Message(%msg)
{
	if($zBot_isActive)
	{
		echo("\c4zBot:" SPC %msg);
		schedule(400, 0, commandToServer, 'MessageSent', "zBot:" SPC %msg);
		//commandtoserver('MessageSent',"zBot:" SPC %msg);
	}
}

function zBotCmdReload(%name,%args)
{
	exec("./main.cs");
	zBot_Message("Reloaded.");
}

function zBotCmdGet(%name,%args)
{
	if(%args $= "ping")
	{
		%ping = serverConnection.getPing();
		if(%ping > 50)
		{
			%quality = "decent";
		}
		if(%ping > 100)
		{
			%quality = "not bad";
		}
		if(%ping < 50)
		{
			%quality = "good";
		}
		if(%ping < 25)
		{
			%quality = "amazing";
		}
		if(%ping < 10)
		{
			%quality = "lightning fast";
		}
		zBot_Message("Your ping is " @ %quality @ ":" SPC %ping @ "ms.");
	}
	if(%args $= "ip")
	{
		%ip = serverConnection.getRawIP();
		zbot_Message("Server IP:" SPC %ip @ ". Copied to clipboard.");
		setClipboard(%ip);
	}
}

function zBotCmdShutdown(%name,%args)
{
	zBot_Message("Shutting off.");
	$zBot_isActive = false;
}

function zBotCmdStartup(%name,%args)
{
	$zBot_isActive = true;
	zBot_Message("Welcome back.");
}

function zBotCmdSay(%name,%args)
{
	if(%args $= "something in french" || %args $= "something french")
	{
		zBot_Message("Je t'aime, Zapk.");
		return;
	}
	%args = strReplace(%args, "You're", "I'm");
	%args = strReplace(%args, "you're", "I'm");
	%args = strReplace(%args, "Yourself", "myself");
	%args = strReplace(%args, "yourself", "myself");
	%args = strReplace(%args, "You", "I");
	%args = strReplace(%args, "you", "I");
	%args = strReplace(%args, "Me", "you");
	%args = strReplace(%args, "me", "you");
	zBot_Message(%args);
}

function zBotCmdEval(%name,%args)
{
	$zBot_evalNoError = 0;
	eval(%args @ " $zBot_evalNoError = 1;");
	if(!$zBot_evalNoError){ zBot_Message("Might want to retry that."); }
	return;
}

function zBotCmdTell(%name,%args)
{
	%args = strReplace(%args, "he's", "you're");
	%args = strReplace(%args, "i'm", "Zapk is");
	%args = strReplace(%args, "she's", "you're");
	%args = strReplace(%args, "he", "you");
	%args = strReplace(%args, "she", "you");
	%args = strReplace(%args, "his", "your");
	%args = strReplace(%args, "her", "your");
	%target = firstWord(%args);
	%message = restWords(%args);
	zBot_Message(%target @ "," SPC %message);
}

function zBotCmdHi(%name,%args)
{
	%random = getRandom(1, 10);
	%greet[1] = "Hello!";
	%greet[2] = "Hi there!";
	%greet[3] = "Hola.";
	%greet[4] = "I'm studying. Bugger off.";
	%greet[5] = "Can I help you?";
	%greet[6] = "Need something?";
	%greet[7] = "Hey!";
	%greet[8] = "Hey.";
	%greet[9] = "How do you do?";
	%greet[10] = "Bonjour.";
	zBot_Message(%greet[%random]);
}

function zBotCmdCalculate(%name,%args)
{
	zBot_Math(%args);
	if(%args $= "mind")
	{
		zBot_Message("mind = blown");
	}
	else if(%args $= "the meaning of life, the universe and everything")
	{
		zBot_Message("the meaning of life, the universe and everything = 42");
	}
	else
	{
		zBot_Message(%args SPC "=" SPC $zBot_MathString);
	}
}

function zBotCmdLearn(%name,%args)
{
	%args = strReplace(%args, ".", "");
	%args = strReplace(%args, " ", "_");
	if($zBot_Knowledge[%args] $= "" && $zBot_Knowledge[%args] == 0)
	{
		zBot_Message("Describe" SPC strReplace(%args, "_", " ") @ ".");
		$zBot_isDescribing = true;
		$zBot_DescriptionParent = %args;
	}
}

function zBotCmdReLearn(%name,%args)
{
	%args = strReplace(%args, ".", "");
	%args = strReplace(%args, " ", "_");
	if($zBot_Knowledge[%args] !$= "")
	{
		zBot_Message("Re-describe" SPC strReplace(%args, "_", " ") @ ".");
		$zBot_isDescribing = true;
		$zBot_DescriptionParent = %args;
	}
	else
	{
		zBot_Message("I don't even know what that is yet! Can you tell me?");
	}
}

function zBotCmdDescribe(%name,%args)
{
	%args = strReplace(%args, ".", "");
	%args = strReplace(%args, " ", "_");
	if($zBot_Knowledge[%args] $= "" && $zBot_Knowledge[%args] == 0)
	{
		zBot_Message("I don't know what that is. Can you tell me?");
		return;
	}
	zBot_Message($zBot_Knowledge[%args]);
}

function zBotCmdDefine(%name,%args)
{
	zBotCmdDescribe(%name,%args);
}

function zBotCmdForget(%name,%args)
{
	%args = strReplace(%args, ".", "");
	%args = strReplace(%args, " ", "_");
	if($zBot_Knowledge[%args] $= "" && $zBot_Knowledge[%args] == 0)
	{
		zBot_Message("I don't even know what that is, I swear.");
		return;
	}
	deleteVariables("$zBot_Knowledge" @ %args);
	export("$zBot_Knowledge*", "config/client/zBot/knowledge.cs");
	zBot_Message("Okay, i've erased" SPC %args SPC "from my memory.");
}

function zBotCmdRandom(%name,%args)
{
	%one = firstWord(%args);
	%two = restWords(%args);
	%results = getRandom(%one, %two);
	zBot_Message("Random interval between" SPC %one SPC "and" SPC %two @ ":" SPC %results);
}

function zBotCmdCalc(%name,%args) { zBotCmdCalculate(%name,%args); }
function zBotCmdMath(%name,%args) { zBotCmdCalculate(%name,%args); }
function zBotCmdWhatis(%name,%args) { zBotCmdCalculate(%name,%args); }

function zBotCmdInfo(%name,%args)
{
	zBot_Math(%args);
	if(%args $= "date")
	{
		%date = strReplace(getWord(getDateTime(),0),"/",".");
		zBot_Message("The date is:" SPC %date);
	}
	else if(%args $= "time")
	{
		%time = getWord(getDateTime(),1);
		zBot_Message("The time is:" SPC %time);
	}
	else
	{
		zBot_Message("Please specify what you want to know.");
	}
}

function zBotCmdAfk(%name,%args)
{
	if(%args !$= "")
	{
		$zBot_AFKReason = %args;
	}
	else
	{
		$zBot_AFKReason = "";
	}
	if($zBot_isAFK)
	{
		$zBot_isAFK = false;
		cancel($zBot_AFKSchedule);
		zBot_Message("Zapk is no longer AFK.");
		return;
	}
	if(!$zBot_isAFK)
	{
		$zBot_isAFK = true;
		$zBot_minutesAFK = 0;
		if($zBot_AFKReason $= "")
		{
			zBot_Message("Zapk is now AFK.");
		}
		else
		{
			zBot_Message("Zapk is now AFK. Reason:" SPC $zBot_AFKReason);
		}
		schedule(300000, 0, zBot_AFKSchedule);
	}	
}

function zBot_AFKSchedule()
{
	$zBot_minutesAFK = $zBot_minutesAFK + 5;
	if($zBot_AFKReason $= "" && $zBot_isAFK)
	{
		zBot_Message("Zapk has been AFK for" SPC $zBot_minutesAFK SPC "minutes.");
	}
	else if($zBot_isAFK)
	{
		zBot_Message("Zapk has been AFK for" SPC $zBot_minutesAFK SPC "minutes. Reason:" SPC $zBot_AFKReason);
	}
	if($zBot_isAFK)
	{
		$zBot_AFKSchedule = schedule(300000, 0, zBot_AFKSchedule);
	}
}